selectComp :: [a] -> Int -> a
selectComp xs i  =  the [ x | (j,x) <- zip [0..] xs, j == i ]
  where
  the [x]  =  x

selectCompRec :: [a] -> Int -> a
selectCompRec (x:xs) 0  =  x
selectCompRec (x:xs) i  =  selectCompRec xs (i-1)

takeComp :: Int -> [a] -> [a]
takeComp i xs  =  [ x | (j,x) <- zip [0..] xs, j < i ]

takeCompRec :: Int -> [a] -> [a]
takeCompRec 0 xs      =  []
takeCompRec i []      =  []
takeCompRec i (x:xs)  =  x : takeCompRec (i-1) xs

dropComp :: Int -> [a] -> [a]
dropComp i xs  =  [ x | (j,x) <- zip [0..] xs, j >= i ]

dropCompRec :: Int -> [a] -> [a]
dropCompRec 0 xs      =  xs
dropCompRec i []      =  []
dropCompRec i (x:xs)  =  dropCompRec (i-1) xs
